/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.builtin.t;

import java.util.GregorianCalendar;
import java.util.TimeZone;

import net.morilib.awk.builtin.AwkUnaryArgs;
import net.morilib.awk.io.AwkFiles;
import net.morilib.awk.namespace.AwkNamespace;
import net.morilib.awk.value.AwkInteger;
import net.morilib.awk.value.AwkValue;

/**
 * 時間の要素を求める関数の基底クラスです。
 *
 *
 * @author MORIGUCHI, Yuichiro 2013/04/13
 */
public abstract class AbstractTAttr extends AwkUnaryArgs {

	/**
	 * 関数を生成します。
	 * 
	 * @param name 関数名
	 */
	protected AbstractTAttr(String name) {
		super(name);
	}

	/**
	 * java.util.Calendarのフィールド名を指定します。
	 * 
	 * @return フィールド名
	 */
	protected abstract int getField();

	/**
	 * オフセットを指定します。
	 * 
	 * @param t タイムゾーン
	 * @return オフセット
	 */
	protected int getOffset(TimeZone t) {
		return 0;
	}

	@Override
	public AwkValue apply(AwkNamespace ns, AwkFiles o, AwkValue a1) {
		GregorianCalendar c = new GregorianCalendar();

		c.setTimeInMillis(a1.toInteger().longValue());
		return AwkInteger.valueOf(c.get(
				getField()) - getOffset(TimeZone.getDefault()));
	}

}
